package mi;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.tobesoft.platform.PlatformRequest;
import com.tobesoft.platform.PlatformResponse;
import com.tobesoft.platform.data.ColumnInfo;
import com.tobesoft.platform.data.Dataset;
import com.tobesoft.platform.data.DatasetList;
import com.tobesoft.platform.data.VariableList;

/**
 * Servlet implementation class for Servlet: DefaultService
 *
 */
public class DefaultService extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet
{
    private static final long serialVersionUID = 1L;

	public DefaultService()
    {
        super();
        System.out.println("DefaultService");
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
        // TODO Auto-generated method stub
        doPost(request, response);
    }

    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
        String serviceId = request.getParameter("service_id");
        String target    = request.getParameter("target");

        /*********************************************************
         * response   Ѵ.
         * output variable list, output dataset list Ѵ.
         * (MiPlatform    ִ  · )
         *********************************************************/
        PlatformResponse platformResponse = new PlatformResponse(response, PlatformRequest.XML, "utf-8");
        VariableList    outVariableList  = new VariableList();
        DatasetList     outDatasetList   = new DatasetList();


        if(serviceId != null && serviceId.equals("dbm_svc_get_svclist")) {
            System.out.println("dbm_svc_get_svclist");

            try {

                Dataset outDataset = new Dataset();
                outDataset.addColumn("name", ColumnInfo.COLUMN_TYPE_STRING, 255);

                int row = outDataset.appendRow();
                outDataset.setColumn(row, "name", "testService");

                // Output Dataset  Output Dataset List  ´.
                outDatasetList.add("output", outDataset);

                // Output Vairable  Ѵ.
                outVariableList.add("ErrorCode", 0);
                outVariableList.add("ErrorMsg",  "ȸ ");

            } catch(Exception e) {

                // Output Vairable  Ѵ.
                outVariableList.add("ErrorCode", -1);
                outVariableList.add("ErrorMsg",  e.toString());

            } finally {

                // ȸ (Output Dataset List, Output Variable List) MiPlatform  
                platformResponse.sendData(outVariableList, outDatasetList);
            }

        } else if(serviceId != null && serviceId.equals("dbm_get_iolayout")) {
            System.out.println("dbm_get_iolayout");

            /*********************************************************
             * db select
             *********************************************************/
            // Connection
            Connection conn     = null;
            String strDriver    = "oracle.jdbc.driver.OracleDriver";
            //String strUrl       = "jdbc:oracle:thin:@210.107.96.211:1521:XE";
            String strUrl       = "jdbc:oracle:thin:@localhost:1521:XE";
            String strUser      = "blue";
            String strPwd       = "trigun";

            try {
                Class.forName(strDriver);
            } catch(ClassNotFoundException e) {
                e.printStackTrace();
                System.out.println("JDBC ̹ ã  ϴ." + e.toString());
            }

            try {
                conn = DriverManager.getConnection(strUrl,strUser,strPwd);
                System.out.println("Ἲ");
            } catch(Exception e) {
                System.out.println("DB   ϴ." + e.toString());
                conn = null;
            }

            if(conn == null) {

            } else {

                PreparedStatement pstmtTables   = null;
                PreparedStatement pstmtColumns = null;
                ResultSet rsTables = null;
                ResultSet rsColumns = null;

                PrintWriter printWriter = response.getWriter();

                try {

                    if(target != null && target.equals("testService")) {

                        System.out.println("testService");
                        String selectTableListQuery = "SELECT * FROM ALL_TABLES WHERE OWNER = 'BLUE' ORDER BY TABLE_NAME";
                        pstmtTables = conn.prepareStatement(selectTableListQuery);
                        rsTables    = pstmtTables.executeQuery();

                        StringBuffer sbIOLayout = new StringBuffer();
                        sbIOLayout.append("<?xml version='1.0' encoding='euc-kr'?>\n");
                        sbIOLayout.append("<class2>\n");
                        sbIOLayout.append("\t<member_var>\n");
                        sbIOLayout.append("\t\t<colinfo id='col01' type='STRING' size='100'/>\n");
                        sbIOLayout.append("\t\t<colinfo id='col02' type='STRING' size='100'/>\n");
                        sbIOLayout.append("\t\t<colinfo id='col03' type='STRING' size='100'/>\n");
                        sbIOLayout.append("\t</member_var>\n");
                        sbIOLayout.append("\t<dataset id='ds_input' io='input'>\n");
                        sbIOLayout.append("\t\t<colinfo id='col01' type='INT' size='100'/>\n");
                        sbIOLayout.append("\t\t<colinfo id='col02' type='STRING' size='100'/>\n");
                        sbIOLayout.append("\t\t<colinfo id='col03' type='STRING' size='100'/>\n");
                        sbIOLayout.append("\t</dataset>\n");

                        while(rsTables.next()) {

                            String selectTableDetailQuery = "SELECT * FROM ALL_TAB_COLUMNS WHERE TABLE_NAME = '"+rsTables.getString("TABLE_NAME")+"'";
                            System.out.println(selectTableDetailQuery);

                            pstmtColumns = conn.prepareStatement(selectTableDetailQuery);
                            rsColumns    = pstmtColumns.executeQuery();

                            sbIOLayout.append("\t<dataset id='"+rsTables.getString("TABLE_NAME")+"' io='output'>\n");
                            while(rsColumns.next()) {

                                if(rsColumns.getString("DATA_TYPE").equals("NUMBER")) {

                                    sbIOLayout.append("\t\t<colinfo id='"+rsColumns.getString("COLUMN_NAME")+"' type='DECIMAL' size='"+rsColumns.getInt("DATA_LENGTH")+"'/>\n");

                                } else if(rsColumns.getString("DATA_TYPE").equals("CHAR") || rsColumns.getString("DATA_TYPE").equals("VARCHAR") || rsColumns.getString("DATA_TYPE").equals("VARCHAR2")){

                                    sbIOLayout.append("\t\t<colinfo id='"+rsColumns.getString("COLUMN_NAME")+"' type='STRING' size='"+rsColumns.getInt("DATA_LENGTH")+"'/>\n");

                                } else if(rsColumns.getString("DATA_TYPE").equals("DATE") || rsColumns.getString("DATA_TYPE").equals("DATETIME")){

                                    sbIOLayout.append("\t\t<colinfo id='"+rsColumns.getString("COLUMN_NAME")+"' type='DATE' size='"+rsColumns.getInt("DATA_LENGTH")+"'/>\n");

                                }
                            }
                            sbIOLayout.append("\t</dataset>\n");
                        }
                        sbIOLayout.append("</class2>\n");

                        response.addHeader("Content-Type", "text/xml;charset=utf-8");
                        printWriter.write(sbIOLayout.toString());

                        printWriter.flush();

                    }

                } catch(SQLException se) {

                } catch(Exception e) {

                } finally {

                    if(rsTables     != null) try { rsTables.close();     } catch(Exception e) {}
                    if(rsColumns    != null) try { rsColumns.close();    } catch(Exception e) {}
                    if(pstmtTables  != null) try { pstmtTables.close();  } catch(Exception e) {}
                    if(pstmtColumns != null) try { pstmtColumns.close(); } catch(Exception e) {}

                    if(conn  != null) try { conn.close();  } catch(Exception e) {}

                    if(printWriter != null) try { printWriter.close(); } catch(Exception e) {}
                }
            }
        }

    }
}